Index: Dev/branches/rest-dojo-ui/client/rft/app/Controller.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/app/Controller.js	(revision 407)
+++ Dev/branches/rest-dojo-ui/client/rft/app/Controller.js	(revision 407)
@@ -0,0 +1,145 @@
+define([
+    'dojo/_base/declare',
+    'dojo/hash',
+    'dojo/io-query',
+    'dojo/topic',
+    './Page',
+    'dijit/registry'
+],function(declare,hash,ioQuery,topic,Page,registry){
+
+
+    var Controller = declare(null,{
+        _started: false,
+        _routes: null,
+        _container: null,
+        _previousHash: null,
+        _previousContent: null,
+
+        _paramMatch: /:(\w[\w\d]*)/g,
+        _paramReplace: "([^\\/]+)",
+
+        constructor: function() {
+            this._routes = [];
+        },
+        startup: function() {
+            if ( this._started ) { return; }
+
+            var self = this;
+
+            this._container = registry.byId('content');
+            if ( !this._container || !this._container.addChild ) {
+                throw new Error("Cannot find container widget with id 'content'.");
+            }
+            this._started = true;
+
+            if ( hash() === "" ) {
+                hash("#!/");
+            }
+            this._handlePathChange(hash());
+			topic.subscribe("/dojo/hashchange", function(){
+                self._handlePathChange.apply(self,arguments);
+            });
+        },
+        register: function(route) {
+            var self = this;
+            var callback;
+            if ( route.callback ) {
+                callback = function(params){
+                    self._setContent(route.callback(params));
+                };
+            } else if ( route.redirect ) {
+                callback = function(params){
+                    self.go(route.redirect);
+                };
+            } else if ( route.constructor ) {
+                callback = function(params){
+                    self._setContent( new route.constructor(params) );
+                };
+            }
+            if ( callback ) {
+                if ( route.path ) {
+                    this._routes.push(this._createRoute(route.path,callback));
+                } else {
+                    this._defaultCallback = callback;
+                }
+            } else {
+                console.warn("Route "+(route.path||"default")+" has no action.");
+            }
+        },
+        _createRoute: function(path,callback) {
+            var match, route = {};
+            route.callback = callback;
+            route.paramNames = [];
+			while((match = this._paramMatch.exec(path)) !== null){
+				route.paramNames.push(match[1]);
+			}
+            path = path.replace(this._paramMatch, this._paramReplace);
+            route.regexp = new RegExp('^!'+path+'(!.*)?$');
+            return route;
+        },
+        _handlePathChange: function(newHash) {
+            if ( this._previousHash === newHash ) { return; }
+            this._previousHash = newHash;
+
+            for (var i = this._routes.length-1; i >= 0; i--) {
+                var result;
+                var route = this._routes[i];
+
+                if ((result = route.regexp.exec(newHash)) !== null) {
+                    var numParams = route.paramNames.length;
+
+                    var params = {};
+                    for (var j = 0; j < numParams; j++) {
+                        params[route.paramNames[j]] = result[j+1];
+                    }
+
+                    if ( result.length > numParams+1 ) {
+                        params.options = ioQuery.queryToObject(result[numParams]);
+                    }
+
+                    try {
+                        route.callback(params);
+                    } catch(err) {
+                        console.warn("Page change failed.",err);
+                    }
+                    return;
+                }
+            }
+
+            try {
+                this._defaultCallback();
+            } catch(err) {
+                console.warn("Default page failed.",err);
+            }
+        },
+        go: function(path,args) {
+            if ( !this._started ) { return; }
+            var newHash = this._pathToHash(path,args);
+            this._handlePathChange(newHash);
+            hash(newHash);
+        },
+        _pathToHash: function(path,args) {
+            var hash = '!'+path;
+            if ( args ) {
+                hash += '!'+ioQuery.objectToQuery(args);
+            }
+            return hash;
+        },
+        _setContent: function(widget) {
+            if ( this._previousContent ) {
+                this._previousContent.destroyRecursive();
+                this._previousContent = null;
+            }
+            widget.region = 'center';
+            this._container.addChild(widget);
+            this._previousContent = widget;
+        },
+        _defaultCallback: function() {
+            this._setContent(new Page({
+                templateString: "<div>Requested page not found. Go <a href=\"#!/\">home</a>.</div>"
+            }));
+        }
+    });
+
+    return new Controller();
+});
Index: Dev/branches/rest-dojo-ui/client/rft/app/Page.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/app/Page.js	(revision 407)
+++ Dev/branches/rest-dojo-ui/client/rft/app/Page.js	(revision 407)
@@ -0,0 +1,10 @@
+define([
+    'dojo/_base/declare',
+    'dijit/_TemplatedMixin',
+    'dijit/_WidgetsInTemplateMixin',
+    'dijit/layout/BorderContainer'
+],function(declare,_TemplatedMixin,_WidgetsInTemplateMixin,BorderContainer){
+    return declare([BorderContainer,_TemplatedMixin,_WidgetsInTemplateMixin],{
+        templateString: '<div>Empty page.</div>'
+    });
+});
Index: Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticReadStore.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticReadStore.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticReadStore.js	(revision 407)
@@ -7,5 +7,5 @@
     ],function(declare, json, lang, xhr, QueryReadStore) {
 
-    return declare("rft.elastic.ElasticReadStore", QueryReadStore, {
+    return declare(QueryReadStore, {
         fetch:function(request){
             var attr = Object.keys(request.query)[0];
Index: Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticSearchFilteringSelect.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticSearchFilteringSelect.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/elastic/ElasticSearchFilteringSelect.js	(revision 407)
@@ -3,5 +3,5 @@
     'dijit/form/FilteringSelect'
 ], function(declare, FilteringSelect) {
-    return declare("rft.elastic.ElasticSearchFilteringSelect", FilteringSelect, {
+    return declare(FilteringSelect, {
          // custom min input character count to trigger search
          minKeyCount: 3,
Index: Dev/branches/rest-dojo-ui/client/rft/package.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/package.js	(revision 407)
+++ Dev/branches/rest-dojo-ui/client/rft/package.js	(revision 407)
@@ -0,0 +1,15 @@
+var profile = (function(){
+    return {
+        resourceTags: {
+            amd: function (filename, mid) {
+                return /\.js$/.test(filename);
+            },
+            declarative: function (filename, mid) {
+                return /\.html$/.test(filename);
+            },
+            copyOnly: function(filename,mid) {
+                return false;
+            }
+        }
+    };
+})();
Index: Dev/branches/rest-dojo-ui/client/rft/pages/index.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/index.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/index.js	(revision 407)
@@ -1,16 +1,22 @@
-define(['dojo/_base/declare','dojo/_base/lang','rft/content','rft/ui/_Page'],
-    function(declare,lang,content,_Page){
-        return declare('rft.pages.index',[_Page],{
-            selectedObject: null,
-            onVisit: function() {
-                this.btnContentCreate.on("click",function(){ content.goTo("sessions"); });
-                this.btnContentFacilitate.on("click",function(){ content.goTo("run"); });
-                this.btnSurveys.on("click",function(){ content.goTo("surveys"); });
-                this.btnQuestions.on("click",function(){ content.goTo("questions"); });
-                this.btnApplications.on("click",function(){ content.goTo("applications"); });
-                this.btnDashboards.on("click",function(){ content.goTo("dashboards"); });
-                this.btnResults.on("click",function(){ content.goTo("results"); });
-            }
-        });
+define([
+    'dojo/_base/declare',
+    '../app/Controller',
+    '../app/Page',
+    'dojo/text!./index.html'
+],function(declare,Controller,Page,template){
+    return declare([Page],{
+        templateString: template,
+        selectedObject: null,
+        startup: function() {
+            if ( this._started ) { return; }
+            this.inherited(arguments);
+            this.btnContentCreate.on("click",function(){ Controller.go("/sessions"); });
+            this.btnContentFacilitate.on("click",function(){ Controller.go("/run"); });
+            this.btnSurveys.on("click",function(){ Controller.go("/surveys"); });
+            this.btnQuestions.on("click",function(){ Controller.go("/questions"); });
+            this.btnApplications.on("click",function(){ Controller.go("/applications"); });
+            this.btnDashboards.on("click",function(){ Controller.go("/dashboards"); });
+            this.btnResults.on("click",function(){ Controller.go("/results"); });
+        }
     });
-
+});
Index: Dev/branches/rest-dojo-ui/client/rft/pages/question.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 407)
@@ -4,61 +4,63 @@
     'dojo/_base/event',
     'dojo/_base/lang',
-    'rft/store',
-    'rft/content',
-    'rft/ui/_Page',
-    'rft/ui/QuestionEditorPreview',
-    'rft/ui/QuestionEditorToolkit'
-    ],function(declare, Deferred, event, lang, store, content, _Page, QuestionEditorPreview, QuestionEditorToolkit){
-        return declare('rft.pages.question', [_Page], {
-            question: null,
-            _toolkit: null,
-            _preview: null,
-            
-            onVisit: function() {
-                if (this.pageArgs.uid) {
-                    Deferred.when(store.get(this.pageArgs.uid))
-                    .then(lang.hitch(this, function(obj) {
-                        this.question = obj;
-                        this._refresh();
-                    }));
-                } else {
-                    throw new Error("Error: no reference to object set!");
-                }
-                this._setupEditor();
-            },
-            onLeave: function() {
-                this.inherited(arguments);
-            },
-            _refresh: function () {
-                this._toolkit.set('value',this.question);
-                this._preview.appendItems(this.question.content || []);
-            },
-            _onSave: function(evt) {
-                lang.mixin(this.question, this._toolkit.get('value'));
-                this.question.content = this._preview.getItems();
-                store.put(this.question)
-                .then(function() {
-                    content.goTo('questions');
-                });
-                evt && event.stop( evt );
-                return false;
-            },
-            _onDiscard: function() {
-                content.goTo('questions');
-                return true;
-            },
-            _setupEditor: function() {
-                this._toolkit = new QuestionEditorToolkit({
-                },this.QuestionEditorToolkitNode);
-                this._toolkit.on('submit',lang.hitch(this,"_onSave"));
-                this._toolkit.startup();
+    '../store',
+    '../app/Controller',
+    '../app/Page',
+    '../ui/QuestionEditorPreview',
+    '../ui/QuestionEditorToolkit',
+    'dojo/text!./question.html'
+],function(declare, Deferred, event, lang, store, Controller, Page, QuestionEditorPreview, QuestionEditorToolkit, template){
+    return declare([Page], {
+        templateString: template,
+        question: null,
+        _toolkit: null,
+        _preview: null,
+        
+        startup: function() {
+            if ( this._started ) { return; }
+            this.inherited(arguments);
+            if (this.questionId) {
+                Deferred.when(store.get(this.questionId))
+                .then(lang.hitch(this, function(obj) {
+                    this.question = obj;
+                    this._refresh();
+                }));
+            } else {
+                throw new Error("Error: no reference to object set!");
+            }
+            this._setupEditor();
+        },
+        onLeave: function() {
+            this.inherited(arguments);
+        },
+        _refresh: function () {
+            this._toolkit.set('value',this.question);
+            this._preview.appendItems(this.question.content || []);
+        },
+        _onSave: function(evt) {
+            lang.mixin(this.question, this._toolkit.get('value'));
+            this.question.content = this._preview.getItems();
+            store.put(this.question)
+            .then(function() {
+                Controller.go('/questions');
+            });
+            evt && event.stop( evt );
+            return false;
+        },
+        _onDiscard: function() {
+            Controller.go('/questions');
+            return true;
+        },
+        _setupEditor: function() {
+            this._toolkit = new QuestionEditorToolkit({
+            },this.QuestionEditorToolkitNode);
+            this._toolkit.on('submit',lang.hitch(this,"_onSave"));
+            this._toolkit.startup();
 
-                this._preview = new QuestionEditorPreview({ 
-                    region: 'center'
-                },this.QuestionEditorPreviewNode);
-                this._preview.startup();
-                this._supportingWidgets.push(this._toolkit, this._preview);
-            }
-        });
+            this._preview = new QuestionEditorPreview({ 
+            },this.QuestionEditorPreviewNode);
+            this._preview.startup();
+            this._supportingWidgets.push(this._toolkit, this._preview);
+        }
+    });
 });
-
Index: Dev/branches/rest-dojo-ui/client/rft/pages/questions.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/questions.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/questions.js	(revision 407)
@@ -4,42 +4,43 @@
     'dojo/_base/event',
     'dojo/_base/lang',
-    'rft/content',
-    'rft/store',
-    'rft/ui/_Page',
-    'rft/ui/TabbedQuestionBrowser'
-    ],function(declare,Deferred,event,lang,content,store,_Page,TabbedQuestionBrowser) {
-        return declare('rft.pages.questions',[_Page],{
-            constructor: function() {
-                this.inherited(arguments);
-            },
-            onVisit: function() {
-                this.questionBrowser = new TabbedQuestionBrowser({
-                    region: 'center',
-                    'class': 'blue',
-                    itemActions: {
-                        'Edit': {
-                            callback: lang.hitch(this,"onEditQuestion"),
-                               icon: 'Edit',
-                               description: 'Edit question'
-                        }
+    '../app/Controller',
+    '../store',
+    '../app/Page',
+    '../ui/TabbedQuestionBrowser',
+    'dojo/text!./questions.html'
+],function(declare,Deferred,event,lang,Controller,store,Page,TabbedQuestionBrowser,template) {
+    return declare([Page],{
+        templateString: template,
+        startup: function() {
+            if ( this._started ) { return; }
+            this.inherited(arguments);
+            this.questionBrowser = new TabbedQuestionBrowser({
+                region: 'center',
+                'class': 'blue',
+                itemActions: {
+                    'Edit': {
+                        callback: lang.hitch(this,"onEditQuestion"),
+                           icon: 'Edit',
+                           description: 'Edit question'
                     }
-                },this.questionBrowser);
-                this.questionBrowser.startup();
-            },
-            _refresh: function() {
-                Deferred.when(store.query('_design/default/_view/by_type',{key: 'Question'}))
-                .then(lang.hitch(this,function(items){
-                    this._list.setItems(items);
-                }));
-            },
-            onNewQuestion: function() {
-                Deferred.when(store.add({type:'Question'}))
-                .then(lang.hitch(this,function(question){
-                    this.onEditQuestion(question);
-                }));
-            },
-            onEditQuestion: function(question) {
-                content.goTo("question", {uid: question._id});
-            }
-        });
+                }
+            },this.questionBrowser);
+            this.questionBrowser.startup();
+        },
+        _refresh: function() {
+            Deferred.when(store.query('_design/default/_view/by_type',{key: 'Question'}))
+            .then(lang.hitch(this,function(items){
+                this._list.setItems(items);
+            }));
+        },
+        onNewQuestion: function() {
+            Deferred.when(store.add({type:'Question'}))
+            .then(lang.hitch(this,function(question){
+                this.onEditQuestion(question);
+            }));
+        },
+        onEditQuestion: function(question) {
+            Controller.go("/question/"+question._id);
+        }
+    });
 });
Index: Dev/branches/rest-dojo-ui/client/rft/pages/session.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/session.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/session.js	(revision 407)
@@ -5,86 +5,89 @@
     'dojo/_base/event',
     'dojo/_base/Deferred',
-    '../content',
+    '../app/Controller',
     '../store',
     '../elastic/ElasticSearchFilteringSelect',
     '../elastic/ElasticReadStore',
-    '../ui/_Page',
-    '../ui/lists/AccountListView'
-    ],
-    function(array,declare,lang,event,Deferred,ElasticSearchFilteringSelect,ElasticReadStore,store,_Page,content,AccountListView){
-        return declare('rft.pages.session',[_Page],{
-            session: null,
-            _accountList: null,
-            _select: null,
-            onVisit: function() {
-                if ( this.pageArgs.uid ) {
-                    Deferred.when(store.get(this.pageArgs.uid))
-                    .then(lang.hitch(this,function(obj){
-                        this.session = obj;
-                        this._setupAccountList();
-                        this._refresh();
-                    }));
-                    this._setupAutoComplete();
-                } else {
-                    throw "No valid uid or session passed!";
-                }
-            },
-            _refresh: function() {
-                this.titleNode.innerHTML = this.session.title || '';
-                this.propertiesForm.set('value',this.session);
-            },
-            onInvite: function() {
-                this._addAccount(this._select.item.i);
-                this._select.reset();
-            },
-            onSave: function(evt) {
-                lang.mixin(this.session,this.propertiesForm.get('value'));
-                this.session.accounts = array.map(this._accountList.getItems(),function(item){
-                    return store.getIdentity(item);
-                });
-                store.put(this.session)
-                .then(function(){
-                    content.goTo('sessions');
-                });
-                event.stop(evt);
-                return false;
-            },
-            onDiscard: function(evt) {
-                this.propertiesForm.reset();
-                event.stop(evt);
-                content.goTo('sessions');
-                return false;
-            },
-            _addAccount: function(item) {
-                this._accountList.insertItem(item);
-            },
-            _setupAccountList: function() {
-                this._accountList = new AccountListView().placeAt(this.accountListNode);
-                this._accountList.startup();
-                for (var account in this.session.accounts) {
-                    this._accountList.insertItem(this.session.accounts[account]);
-                }
-            },
-            _setupAutoComplete: function() {
-                var accountStore = new ElasticReadStore({
-                    url: "http://localhost:9200/rft/_search",
-                    requestMethod: "POST"
-                });
-                this._select = new ElasticSearchFilteringSelect({
-                    store: accountStore,
-                    autoComplete: false,
-                    required: false,
-                    labelType: "text",
-                    placeHolder: "Enter email address here...",
-                    pageSize: 10,
-                    hasDownArrow: false,
-                    style: "width: 400",
-                    searchAttr: "title"
-                }, this.accountSelector);
-                this._select.startup();
+    '../app/Page',
+    '../ui/lists/AccountListView',
+    'dojo/text!./session.html'
+],function(array,declare,lang,event,Deferred,ElasticSearchFilteringSelect,ElasticReadStore,store,Page,Controller,AccountListView,template){
+    return declare([Page],{
+        templateString: template,
+        session: null,
+        _accountList: null,
+        _select: null,
+        startup: function() {
+            if ( this._started ) { return; }
+            this.inherited(arguments);
+            if ( this.sessionId ) {
+                Deferred.when(store.get(this.sessionId))
+                .then(lang.hitch(this,function(obj){
+                    this.session = obj;
+                    this._setupAccountList();
+                    this._refresh();
+                }));
+                this._setupAutoComplete();
+            } else {
+                throw "No valid uid or session passed!";
             }
+        },
+        _refresh: function() {
+            this.titleNode.innerHTML = this.session.title || '';
+            this.propertiesForm.set('value',this.session);
+        },
+        onInvite: function() {
+            this._addAccount(this._select.item.i);
+            this._select.reset();
+        },
+        onSave: function(evt) {
+            lang.mixin(this.session,this.propertiesForm.get('value'));
+            this.session.accounts = array.map(this._accountList.getItems(),function(item){
+                return store.getIdentity(item);
+            });
+            store.put(this.session)
+            .then(function(){
+                Controller.go('/sessions');
+            });
+            event.stop(evt);
+            return false;
+        },
+        onDiscard: function(evt) {
+            this.propertiesForm.reset();
+            event.stop(evt);
+            Controller.go('/sessions');
+            return false;
+        },
+        _addAccount: function(item) {
+            this._accountList.insertItem(item);
+        },
+        _setupAccountList: function() {
+            this._accountList = new AccountListView().placeAt(this.accountListNode);
+            this._accountList.startup();
+            for (var account in this.session.accounts) {
+                this._accountList.insertItem(this.session.accounts[account]);
+            }
+        },
+        _setupAutoComplete: function() {
+            var accountStore = new ElasticReadStore({
+                url: "http://localhost:9200/rft/_search",
+                requestMethod: "POST"
+            });
+            this._select = new ElasticSearchFilteringSelect({
+                store: accountStore,
+                autoComplete: false,
+                required: false,
+                labelType: "text",
+                placeHolder: "Enter email address here...",
+                pageSize: 10,
+                hasDownArrow: false,
+                style: "width: 400",
+                searchAttr: "title"
+            }, this.accountSelector);
+            this._select.startup();
+        }
 
 
-        });
     });
+});
 
Index: Dev/branches/rest-dojo-ui/client/rft/pages/sessions.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/sessions.js	(revision 406)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/sessions.js	(revision 407)
@@ -3,76 +3,79 @@
     'dojo/_base/lang',
     'dojo/date/stamp',
-    'rft/store',
-    'rft/content',
-    'rft/ui/_Page',
-    'rft/ui/ObjectBox'],
-    function(declare,lang,dateStamp,store,content,_Page,ObjectBox){
-        return declare('rft.pages.sessions',[_Page],{
-            templateActions: null,
-            sessionActions: null,
-            onVisit: function() {
-                this.templateActions = {
-                    "Edit": function(obj){
-                        content.goTo('session',{uid:store.getIdentity(obj)});
-                    },
-                    "Delete": lang.hitch(this,function(obj){
-                        store.remove(store.getIdentity(obj),store.getRevision(obj))
-                        .then(lang.hitch(this,function(){
-                            this._refresh();
-                        }));
-                    }),
-                    "Publish": lang.hitch(this,this._publishSession)
-                };
-                this.sessionActions = {
-                    "Facilitate": function(obj){
-                        content.goTo('run',{uid:store.getIdentity(obj)});
-                    },
-                    "Delete": lang.hitch(this,function(obj){
-                        store.remove(store.getIdentity(obj),store.getRevision(obj))
-                        .then(lang.hitch(this,function(){
-                            this._refresh();
-                        }));
-                    })
-                };
+    '../store',
+    '../app/Controller',
+    '../app/Page',
+    '../ui/ObjectBox',
+    'dojo/text!./sessions.html'
+],function(declare,lang,dateStamp,store,Controller,Page,ObjectBox,template){
+    return declare([Page],{
+        templateString: template,
+        templateActions: null,
+        sessionActions: null,
+        startup: function() {
+            if ( this._started ) { return; }
+            this.inherited(arguments);
+            this.templateActions = {
+                "Edit": function(obj){
+                    Controller.go('/session/'+store.getIdentity(obj));
+                },
+                "Delete": lang.hitch(this,function(obj){
+                    store.remove(store.getIdentity(obj),store.getRevision(obj))
+                    .then(lang.hitch(this,function(){
+                        this._refresh();
+                    }));
+                }),
+                "Publish": lang.hitch(this,this._publishSession)
+            };
+            this.sessionActions = {
+                "Facilitate": function(obj){
+                    Controller.go('run',{uid:store.getIdentity(obj)});
+                },
+                "Delete": lang.hitch(this,function(obj){
+                    store.remove(store.getIdentity(obj),store.getRevision(obj))
+                    .then(lang.hitch(this,function(){
+                        this._refresh();
+                    }));
+                })
+            };
+            this._refresh();
+        },
+        _refresh: function() {
+            this.containerTemplates.set('content','');
+            this.containerSessions.set('content','');
+            this._refreshByType('SessionTemplate',this.containerTemplates.domNode,this.templateActions);
+            this._refreshByType('SessionInstance',this.containerSessions.domNode,this.sessionActions);
+        },
+        _refreshByType: function(type,container,actions) {
+            store.query("_design/default/_view/by_type",{key:type})
+            .forEach(lang.hitch(this,function(obj){
+                var widget = new ObjectBox({
+                    actions: actions
+                }).placeAt(container, "last");
+                widget.startup();
+                widget.set('value',obj);
+            }));
+        },
+        onAddSessionTemplate: function(){
+            store.put({
+                type: 'SessionTemplate'
+            })
+            .then(lang.hitch(this,function(obj){
+                Controller.go('/session/'+store.getIdentity(obj));
+            }));
+        },
+        _publishSession: function(sessionTemplate) {
+            var session = lang.clone(sessionTemplate);
+            delete session[store.idProperty];
+            delete session[store.revProperty];
+            session.type = "SessionInstance";
+            session.publishedDate = dateStamp.toISOString(new Date(),{zulu: true});
+            session.creator = "Igor Mayer";
+            store.add(session)
+            .then(lang.hitch(this,function(){
                 this._refresh();
-            },
-            _refresh: function() {
-                this.containerTemplates.set('content','');
-                this.containerSessions.set('content','');
-                this._refreshByType('SessionTemplate',this.containerTemplates.domNode,this.templateActions);
-                this._refreshByType('SessionInstance',this.containerSessions.domNode,this.sessionActions);
-            },
-            _refreshByType: function(type,container,actions) {
-                store.query("_design/default/_view/by_type",{key:type})
-                .forEach(lang.hitch(this,function(obj){
-                    var widget = new ObjectBox({
-                        actions: actions
-                    }).placeAt(container, "last");
-                    widget.startup();
-                    widget.set('value',obj);
-                }));
-            },
-            onAddSessionTemplate: function(){
-                store.put({
-                    type: 'SessionTemplate'
-                })
-                .then(lang.hitch(this,function(obj){
-                    content.goTo('session',{uid:store.getIdentity(obj)});
-                }));
-            },
-            _publishSession: function(sessionTemplate) {
-                var session = lang.clone(sessionTemplate);
-                delete session[store.idProperty];
-                delete session[store.revProperty];
-                session.type = "SessionInstance";
-                session.publishedDate = dateStamp.toISOString(new Date(),{zulu: true});
-                session.creator = "Igor Mayer";
-                store.add(session)
-                .then(lang.hitch(this,function(){
-                    this._refresh();
-                    this.tabContainer.selectChild(this.sessionsTab);
-                }));
-            }
-        });
+                this.tabContainer.selectChild(this.sessionsTab);
+            }));
+        }
     });
-
+});
